/***********************************************************************
 *      This example program is an excerpt from the book:              *
 *                                                                     *
 *          X Window OSF/Motif Toolkit Programming (I)                 *
 *            - Programming Basics, Resource and Event -               *
 *                                                                     *
 *      Copyright 1994, Hideyuki Hayashi                               *
 *                                                                     *
 *      This program can be distributed without fee, provided          *
 *      that the above copyright notice appear in all copies.          *
 ***********************************************************************/

#include <Xm/XmAll.h>

main(argc, argv)
    int  argc;
    char **argv;
{
    XtAppContext app_context;
    Widget  toplevel, panel, control, label, text, button;
    Arg     al[20];
    int     ac;

    XtSetLanguageProc(NULL, NULL, NULL);

    /* (1) Create toplevel shell (at the initialization of Xt) */
    ac = 0;
    toplevel = XtAppInitialize(&app_context, "Create", NULL, 0,
                               &argc, argv, NULL, al, ac);

    /* (2) Create a rowcolumn as entire background (panel) */
    ac = 0;
    panel = XmCreateRowColumn(toplevel, "panel", al, ac);
    XtManageChild(panel);

    /* (3) Create another rowcolumn on upper area (control) */
    ac = 0;
    control = XmCreateRowColumn(panel, "control", al, ac);
    XtManageChild(control);

    /* (4) Create a label (label) */
    ac = 0;
    label = XmCreateLabel(control, "label", al, ac);
    XtManageChild(label);

    /* (5) Create a text field (text) */
    ac = 0;
    text = XtCreateWidget("text", xmTextFieldWidgetClass, control, al, ac);
    XtManageChild(text);

    /* (6) Create a push button (button) */
    ac = 0;
    button = XtCreateWidget("button", xmPushButtonWidgetClass, panel, al, ac);
    XtManageChild(button);

    XtRealizeWidget(toplevel);
    XtAppMainLoop(app_context);
}
