/***********************************************************************
 *      This example program is an excerpt from the book:              *
 *                                                                     *
 *          X Window OSF/Motif Toolkit Programming (I)                 *
 *            - Programming Basics, Resource and Event -               *
 *                                                                     *
 *      Copyright 1994, Hideyuki Hayashi                               *
 *                                                                     *
 *      This program can be distributed without fee, provided          *
 *      that the above copyright notice appear in all copies.          *
 ***********************************************************************/

#include <Xm/XmAll.h>

/* Called when "Start Second Loop" button is pressed */
static void StartCB(w, client_data, call_data)
    Widget    w;
    XtPointer client_data;
    XtPointer call_data;
{
    int i;

    XtSetSensitive(w, False);  /* Disable "Start Second Loop" button */

    /* Repeat the second loop until some condition met */
    for (i = 0; i < 10; i++) {
        XmUpdateDisplay(w);  /* Process only the Expose events */
        printf("Second event loop\n");
        sleep(1);
    }

    XtSetSensitive(w, True);   /* Enable "Start Second Loop" button again */
}

/* Called when "Perform Other Operation" button is pressed */
static void OtherCB(w, client_data, call_data)
    Widget    w;
    XtPointer client_data;
    XtPointer call_data;
{
    printf("Normal X Event is processed.\n");  /* perform other task */
}

main(argc, argv)
    int  argc;
    char **argv;
{
    XtAppContext app_context;
    Widget toplevel, panel, start, other;
    Arg    al[20];
    int    ac;

    XtSetLanguageProc(NULL, NULL, NULL);
    ac = 0;
    toplevel = XtAppInitialize(&app_context, "Updatedpy", NULL, 0,
                               &argc, argv, NULL, al, ac);
    ac = 0;
    panel = XmCreateRowColumn(toplevel, "panel", al, ac);
    XtManageChild(panel);

    ac = 0;
    start = XmCreatePushButton(panel, "start", al, ac);
    XtManageChild(start);
    XtAddCallback(start, XmNactivateCallback, StartCB, NULL);

    ac = 0;
    other = XmCreatePushButton(panel, "other", al, ac);
    XtManageChild(other);
    XtAddCallback(other, XmNactivateCallback, OtherCB, NULL);

    XtRealizeWidget(toplevel);
    XtAppMainLoop(app_context);
}
